/////////////////////////////////////////////////////////////////////////
// adam setapen (asetapen)                  how to make (almost) anything
// 10.24.2010                                               MIT media lab
// button_motor_test.c
//      Test program for pushing a button and having a motor run and
//  	an LED light up
//
//   0110000101110011011001010111010001100001011100000110010101101110
//   0110                       _                                0110
//   0001         __ _ ___  ___| |_ __ _ _ __   ___ _ __         0001
//   0110        / _` / __|/ _ \ __/ _` | '_ \ / _ \ '_ \        0110
//   1101       | (_| \__ \  __/ || (_| | |_) |  __/ | | |       1101
//   0111        \__,_|___/\___|\__\__,_| .__/ \___|_| |_|       0111
//   0011                               |_|                      0011
//   0110000101110011011001010111010001100001011100000110010101101110

// LED-switch program
#include <avr/io.h>
//#define F_CPU 1e6  //CPU clock speed
#include <avr/delay.h>

#define TRUE 1
#define FALSE 0

#define output(directions,pin) (directions |= pin) // set port direction for output
#define set(port,pin) (port |= pin) // set port pin
#define clear(port,pin) (port &= (~pin)) // clear port pin
#define pin_test(pins,pin) (pins & pin) // test for port pin
#define bit_test(byte,bit) (byte & (1 << bit)) // test for bit set
#define bit_delay_time 8.5 // bit delay for 115200 with overhead
#define bit_delay() _delay_us(bit_delay_time) // RS232 bit delay
#define half_bit_delay() _delay_us(bit_delay_time/2) // RS232 half bit delay
#define char_delay() _delay_ms(10) // char delay

#define serial_port PORTA
#define serial_direction DDRA
#define serial_pins PINA
#define serial_pin_in (1 << PA0)
#define serial_pin_out (1 << PA1)

void get_char(volatile unsigned char *pins, unsigned char pin, char *rxbyte) {
	// read character into rxbyte on pins pin
	//    assumes line driver (inverts bits)
	*rxbyte = 0;
	while (pin_test(*pins,pin))
		// wait for start bit
	;
	
	// delay to middle of first data bit
	half_bit_delay();
	bit_delay();
	
	// unrolled loop to read data bits
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 0);
	else
		*rxbyte |= (0 << 0);
	bit_delay();
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 1);
	else
		*rxbyte |= (0 << 1);
	bit_delay();
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 2);
	else
		*rxbyte |= (0 << 2);
	bit_delay();
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 3);
	else
		*rxbyte |= (0 << 3);
	bit_delay();
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 4);
	else
		*rxbyte |= (0 << 4);
	bit_delay();
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 5);
	else
		*rxbyte |= (0 << 5);
	bit_delay();
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 6);
	else
		*rxbyte |= (0 << 6);
	bit_delay();
	if pin_test(*pins,pin)
		*rxbyte |= (1 << 7);
	else
		*rxbyte |= (0 << 7);
	
	// wait for stop bit
	bit_delay();
	half_bit_delay();
}

void enableDevices() {
    PORTB = _BV(PB2);
	PORTA |= _BV(PA2);
}

void disableDevices() {
	PORTB = 0;
	PORTA &= ~_BV(PA2);
}

int main() {
	static char chr;

    // Setup
    // PA3 = Switch
    // PB2 = LED
	// PA2 = MOSFET
	
    // Enable output on LED pin
    DDRB = _BV(PB2);
	// Enable output on MOSFET pin
	DDRA = _BV(PA2);
	
    // Turn on button pullup resistor
    PORTA = _BV(PA3);
	// Turn off MOSFET output
	PORTA &= ~_BV(PA2);
	
	// set clock divider to /1
	CLKPR = (1 << CLKPCE);
	CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
	
	chr = 'h';
	
    while(TRUE) {
		get_char(&serial_pins, serial_pin_in, &chr);
		if (chr == 'f') {
			enableDevices();
			_delay_ms(10000);
			disableDevices();
			chr = 'h';
		}
		
			//         // Button controller
			//         if (bit_is_set(PINA, PA3)) { // Button has not been pushed
			//             PORTB = 0;
			// PORTA &= ~_BV(PA2);
			//         } else { // Button pushed
			//             PORTB = _BV(PB2);
			// PORTA |= _BV(PA2);
			//         }
    }
}

